osgUtil::StateToCompile Class Reference

`#include <IncrementalCompileOperation>`

Inheritance diagram for osgUtil::StateToCompile:

## Public Types

typedef std::set< osg::Drawable * > | DrawableSet
typedef std::set< osg::StateSet * > | StateSetSet
typedef std::set< osg::Texture * > | TextureSet
typedef std::set< osg::Program * > | ProgramSet
Public Types inherited from osg::NodeVisitor
enum | TraversalMode { TRAVERSE_NONE , TRAVERSE_PARENTS , TRAVERSE_ALL_CHILDREN , TRAVERSE_ACTIVE_CHILDREN }
enum | VisitorType { NODE_VISITOR = 0 , UPDATE_VISITOR , EVENT_VISITOR , COLLECT_OCCLUDER_VISITOR , CULL_VISITOR , INTERSECTION_VISITOR }
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| StateToCompile (GLObjectsVisitor::Mode mode, osg::Object *markerObject)
bool | empty () const
virtual void | apply (osg::Node &node)
virtual void | apply (osg::Drawable &drawable)
virtual void | apply (osg::StateSet &stateset)
virtual void | apply (osg::Texture &texture)
Public Member Functions inherited from osg::NodeVisitor
| NodeVisitor (TraversalMode tm=TRAVERSE_NONE)
| NodeVisitor (VisitorType type, TraversalMode tm=TRAVERSE_NONE)
| NodeVisitor (const NodeVisitor &nv, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual | ~NodeVisitor ()
| META_Object (osg, NodeVisitor) virtual NodeVisitor *asNodeVisitor()
virtual const NodeVisitor * | asNodeVisitor () const
virtual osgUtil::UpdateVisitor * | asUpdateVisitor ()
virtual const osgUtil::UpdateVisitor * | asUpdateVisitor () const
virtual osgUtil::CullVisitor * | asCullVisitor ()
virtual const osgUtil::CullVisitor * | asCullVisitor () const
virtual osgGA::EventVisitor * | asEventVisitor ()
virtual const osgGA::EventVisitor * | asEventVisitor () const
virtual osgUtil::IntersectionVisitor * | asIntersectionVisitor ()
virtual const osgUtil::IntersectionVisitor * | asIntersectionVisitor () const
virtual osg::CullStack * | asCullStack ()
virtual const osg::CullStack * | asCullStack () const
virtual void | reset ()
void | setVisitorType (VisitorType type)
VisitorType | getVisitorType () const
void | setTraversalNumber (unsigned int fn)
unsigned int | getTraversalNumber () const
void | setFrameStamp (FrameStamp *fs)
const FrameStamp * | getFrameStamp () const
void | setTraversalMask (Node::NodeMask mask)
Node::NodeMask | getTraversalMask () const
void | setNodeMaskOverride (Node::NodeMask mask)
Node::NodeMask | getNodeMaskOverride () const
bool | validNodeMask (const osg::Node &node) const
void | setTraversalMode (TraversalMode mode)
TraversalMode | getTraversalMode () const
void | setValueMap (ValueMap *ps)
ValueMap * | getValueMap ()
const ValueMap * | getValueMap () const
ValueMap * | getOrCreateValueMap ()
void | setValueStack (ValueStack *ps)
ValueStack * | getValueStack ()
const ValueStack * | getValueStack () const
ValueStack * | getOrCreateValueStack ()
void | traverse (Node &node)
void | pushOntoNodePath (Node *node)
void | popFromNodePath ()
NodePath & | getNodePath ()
const NodePath & | getNodePath () const
virtual osg::Vec3 | getEyePoint () const
virtual osg::Vec3 | getViewPoint () const
virtual float | getDistanceToEyePoint (const Vec3 &, bool) const
virtual float | getDistanceFromEyePoint (const Vec3 &, bool) const
virtual float | getDistanceToViewPoint (const Vec3 &, bool) const
virtual void | apply (Geometry &geometry)
virtual void | apply (Geode &node)
virtual void | apply (Billboard &node)
virtual void | apply (Group &node)
virtual void | apply (ProxyNode &node)
virtual void | apply (Projection &node)
virtual void | apply (CoordinateSystemNode &node)
virtual void | apply (ClipNode &node)
virtual void | apply (TexGenNode &node)
virtual void | apply (LightSource &node)
virtual void | apply (Transform &node)
virtual void | apply (Camera &node)
virtual void | apply (CameraView &node)
virtual void | apply (MatrixTransform &node)
virtual void | apply (PositionAttitudeTransform &node)
virtual void | apply (AutoTransform &node)
virtual void | apply (Switch &node)
virtual void | apply (Sequence &node)
virtual void | apply (LOD &node)
virtual void | apply (PagedLOD &node)
virtual void | apply (ClearNode &node)
virtual void | apply (OccluderNode &node)
virtual void | apply (OcclusionQueryNode &node)
void | setDatabaseRequestHandler (DatabaseRequestHandler *handler)
DatabaseRequestHandler * | getDatabaseRequestHandler ()
const DatabaseRequestHandler * | getDatabaseRequestHandler () const
void | setImageRequestHandler (ImageRequestHandler *handler)
ImageRequestHandler * | getImageRequestHandler ()
const ImageRequestHandler * | getImageRequestHandler () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Public Attributes

DrawableSet | _drawablesHandled
StateSetSet | _statesetsHandled
GLObjectsVisitor::Mode | _mode
DrawableSet | _drawables
TextureSet | _textures
ProgramSet | _programs
bool | _assignPBOToImages
osg::ref_ptr< osg::PixelBufferObject > | _pbo
osg::ref_ptr< osg::Object > | _markerObject

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const
Protected Attributes inherited from osg::NodeVisitor
VisitorType | _visitorType
unsigned int | _traversalNumber
ref_ptr< FrameStamp > | _frameStamp
TraversalMode | _traversalMode
Node::NodeMask | _traversalMask
Node::NodeMask | _nodeMaskOverride
NodePath | _nodePath
ref_ptr< DatabaseRequestHandler > | _databaseRequestHandler
ref_ptr< ImageRequestHandler > | _imageRequestHandler
osg::ref_ptr< ValueMap > | _valueMap
osg::ref_ptr< ValueStack > | _valueStack
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Member Typedef Documentation

## DrawableSet

typedef std::set<osg::Drawable*> osgUtil::StateToCompile::DrawableSet

## ProgramSet

typedef std::set<osg::Program*> osgUtil::StateToCompile::ProgramSet

## StateSetSet

typedef std::set<osg::StateSet*> osgUtil::StateToCompile::StateSetSet

## TextureSet

typedef std::set<osg::Texture*> osgUtil::StateToCompile::TextureSet

## Constructor & Destructor Documentation

## StateToCompile()

osgUtil::StateToCompile::StateToCompile | ( | GLObjectsVisitor::Mode | mode,
|  | osg::Object * | markerObject )

## Member Function Documentation

## apply() [1/4]

virtual void osgUtil::StateToCompile::apply | ( | osg::Drawable & | drawable | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [2/4]

virtual void osgUtil::StateToCompile::apply | ( | osg::Node & | node | ) |

virtual

Reimplemented from osg::NodeVisitor.

## apply() [3/4]

virtual void osgUtil::StateToCompile::apply | ( | osg::StateSet & | stateset | ) |

virtual

## apply() [4/4]

virtual void osgUtil::StateToCompile::apply | ( | osg::Texture & | texture | ) |

virtual

## empty()

bool osgUtil::StateToCompile::empty | ( |  | ) | const

inline

References _drawables, _programs, and _textures.

## Member Data Documentation

## _assignPBOToImages

bool osgUtil::StateToCompile::_assignPBOToImages

## _drawables

DrawableSet osgUtil::StateToCompile::_drawables

Referenced by empty().

## _drawablesHandled

DrawableSet osgUtil::StateToCompile::_drawablesHandled

## _markerObject

osg::ref_ptr<osg::Object> osgUtil::StateToCompile::_markerObject

## _mode

GLObjectsVisitor::Mode osgUtil::StateToCompile::_mode

## _pbo

osg::ref_ptr<osg::PixelBufferObject> osgUtil::StateToCompile::_pbo

## _programs

ProgramSet osgUtil::StateToCompile::_programs

Referenced by empty().

## _statesetsHandled

StateSetSet osgUtil::StateToCompile::_statesetsHandled

## _textures

TextureSet osgUtil::StateToCompile::_textures

Referenced by empty().

The documentation for this class was generated from the following file:

- IncrementalCompileOperation